/*
 ============================================================================
 Kaloth's BB4win Plugin Manager! - BBPlugManager
 ============================================================================
 
 This is a nice little header file with some nice utility functions used in
 BBPlugManager.
 
 Blackbox for Windows is free software and so is this plugin
 released under the GNU General Public License (GPL version 2 or later).
  
 You may mess with it as you wish! (But keep it open source please :))
 
 ============================================================================
*/

/*
 ============================================================================
 Includes
 ============================================================================
 */

#include <windows.h>
#include "../../includes/BBApi.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <Wininet.h>
#include <psapi.h>
#include <unzip.h>
#include <shlobj.h>
#include <direct.h>

#pragma comment (lib, "zlib_bor.lib")
#pragma comment (lib, "psapi.lib")
#pragma comment (lib, "wininet.lib")
#pragma comment (lib, "user32.lib")

/*
 ============================================================================
 Definitions and Macros
 ============================================================================
 */

#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0500
#endif

#ifdef __GNUC__
#define _WIN32_IE 0x0500
#define GetBlackboxPath _GetBlackboxPath
#define DLL_EXPORT //__declspec(dllexport)
#define LWA_ALPHA 2
#endif

#ifdef __BORLANDC__
#define DLL_EXPORT
#endif

#ifndef DLL_EXPORT // Removes compiler dependencies
#define DLL_EXPORT __declspec(dllexport)
#endif


#define MAX_CLASSES 50
#define MAX_LINE_LENGTH 100
#define MAX_PLUGINS 100
#define PLUGIN_UPDATE_URL 8
#define pi 3.14159265358979323846
#define TIME_OUT 4000
#define STICKY true
#define TRANS false

#define STREQ(str1, str2) (strcmp((str1), (str2)) == 0)

/*
 ============================================================================
 Data Types and Structures
 ============================================================================
 */

typedef int (*mybeginSlitPlugin)(HINSTANCE hMainInstance, HWND hBBSlit);
typedef int (*mybeginPluginEx)(HINSTANCE hMainInstance, HWND hBBSlit);
typedef int (*mybeginPlugin)(HINSTANCE hPluginInstance);
typedef VOID (*myendPlugin)(HINSTANCE hPluginInstance);
typedef LPCSTR (*mypluginInfo) (int field);

typedef struct{
	char path[MAX_PATH];
	char name[MAX_PATH];
	char URL[MAX_PATH];
	char broams[1000];
	HMODULE instance;
	mybeginSlitPlugin BeginSlit;
	mybeginPluginEx BeginEx;
	mybeginPlugin Begin;
	myendPlugin End;
	mypluginInfo Info;
	bool running;
	bool inuse;
	bool updateavailable;
	bool slitable;
	bool slitaidable;
	bool slitaid;
	bool loadOnStart;
} Plugin;

/*
 ============================================================================
 Plugin Information Fields
 ============================================================================
 */

LPSTR szAppName         = "BBPlugManager";          // The name of our window class, etc.
LPSTR szVersion         = "BBPlugManager 0.7b";   // Used in MessageBox titlebars
LPSTR szInfoVersion     = "0.7b";
LPSTR szInfoAuthor      = "Kaloth";
LPSTR szInfoRelDate     = "2004-10-31";
LPSTR szInfoLink        = "http://www.geocities.com/madant8";
LPSTR szInfoEmail       = "mulletwarriorextreem@hotmail.com";

/*
 ============================================================================
 Global Data
 ============================================================================
 */

HINSTANCE hInstance;
HWND hwndBlackbox, hwndPlugin;
OSVERSIONINFO  osvinfo;
HFONT hFont;

DWORD dwThreadId, WinTrnsdwThreadId;
HANDLE hThread, WinTrnshThread;

HHOOK HKbHook;

HWINEVENTHOOK eventhook_CREATE;

COLORREF TRANSCOLOUR = RGB(255,0,230);

// Paths...
char plugRCFileName[MAX_PATH];
char rcpath[MAX_PATH];
char plugpath[MAX_PATH];
char bbpath[MAX_PATH];
char defaultUpdateURL[MAX_PATH];

// Settings...
bool usingWin2kXP;

StyleItem myStyleItem;

int width;
int height;
int xpos, ypos;

bool alwaysOnTop;
bool snapWindow;
bool hidden;
bool pluginToggle;
bool transparencyEnabled;
int transparencyAlpha;
bool transback;
bool globalTransparency;
int globalTransAlpha;
bool globalSticky;

// Slit stuff...
bool inSlit;
HWND hSlit;

// border stuff...
int bevelWidth;
int borderWidth;
COLORREF borderColor;

// An array to hold all the plugins...
Plugin plugs[MAX_PLUGINS];
int PluginToUpdate = -1;

// Animation Stuff...
float speed, targetSpeed;
float rotation = 0;
BOOL rotating = false;

// Transparency Stuff...
char classes[50][MAX_PATH]; // 50 stored window class names.
bool lookingforwindow = false;

// Sticky Stuff...
char sticky[50][MAX_PATH]; // 50 stored window class names.
bool lookingforwindowmode = STICKY;

// Menu Clipper stuff...
HWINEVENTHOOK eventhook_MENU;
bool clipmenu;

/*
 ============================================================================
 Function Prototypes
 ============================================================================
 */

void UnloadPlugin(Plugin *plug);
char *getFileName(char *path);
char *unzip(char *filename, char *directory);

/*
 ============================================================================
 Animation & Window Drawing Functions
 ============================================================================
 */

DWORD WINAPI ThreadProc(LPVOID lpParam){
	while(speed >= 0){
		InvalidateRect(hwndPlugin, NULL, FALSE);
		//RedrawWindow(hwndPlugin, NULL, NULL, RDW_INVALIDATE | RDW_INTERNALPAINT);
		Sleep(25);
	}
	rotating = false;
}

void StartCogRotation(){
	if(!rotating){
		targetSpeed = pi/10;
		speed = 0;
		rotating = true;
		hThread = CreateThread(NULL, 0, ThreadProc, NULL, 0, &dwThreadId);
	}
}

void StopCogRotation(){
	targetSpeed = 0;
}

void setPoint(POINT *pnt, int x, int y){
	pnt->x = x;
	pnt->y = y;
}

void DrawCog(HDC buf, int cx, int cy, int r){
	HPEN hPen = CreatePen(PS_SOLID, 1, borderColor);
	HPEN hPenOld = (HPEN)SelectObject(buf, hPen);
	
	HBRUSH hbrush = CreateSolidBrush(myStyleItem.Color);
	HBRUSH hbrushOld = (HBRUSH)SelectObject(buf, hbrush);
	
	// Points for cog polygon
	POINT pnt[16];
	
	BOOL even = true;
	int target_x1, target_y1, target_x2, target_y2, point = 0;
	float n = rotation, inc = ((2*pi)/8);
	
	// Cog 1
	while (point < 16){
		// Inner Points
		target_x1 = cx + ((r-2)*sin(n));
		target_y1 = cy + ((r-2)*cos(n));
		// Outer Points
		target_x2 = cx + ((r+2)*sin(n));
		target_y2 = cy + ((r+4)*cos(n));
		
		if(even){
			setPoint(&pnt[point], target_x1, target_y1);
			point++;
			setPoint(&pnt[point], target_x2, target_y2);
			point++;
			setPoint(&pnt[point], target_x2, target_y2);
			point++;
		}else{
			setPoint(&pnt[point], target_x1, target_y1);
			point++;
		}
		
		even = !even;
		
		n += inc;
	}
	
	Polygon(buf, pnt, 16);
	
	SelectObject(buf, hbrushOld);
	DeleteObject(hbrush);
	
	hbrush = CreateSolidBrush(myStyleItem.Color);
	hbrushOld = (HBRUSH)SelectObject(buf, hbrush);
	
	// Cog 2
	point = 0;
	while (point < 16){
		// Inner Points
		target_x1 = cx + ((r-2)*sin(n + inc));
		target_y1 = cy + ((r-2)*cos(n + inc));
		// Outer Points
		target_x2 = cx + ((r+2)*sin(n + inc));
		target_y2 = cy + ((r+4)*cos(n + inc));
		
		if(even){
			setPoint(&pnt[point], target_x1, target_y1);
			point++;
			setPoint(&pnt[point], target_x2, target_y2);
			point++;
			setPoint(&pnt[point], target_x2, target_y2);
			point++;
		}else{
			setPoint(&pnt[point], target_x1, target_y1);
			point++;
		}
		
		even = !even;
		
		n += inc;
	}
	
	Polygon(buf, pnt, 16);
	
	// Clean up
	SelectObject(buf, hbrushOld);
	DeleteObject(hbrush);
	
	SelectObject(buf, hPenOld);
	DeleteObject(hPen);
	
	// Rotate the Cog
	if(rotating){
		rotation -= speed;
		if(rotation >= (2*pi)){
			rotation = 0;
		}else if(rotation <= 0){
			rotation = (2*pi);
		}
		
		//Manage the acceleration..
		if(speed >= targetSpeed){speed -= 0.05;}
		else if(speed < targetSpeed){speed += 0.05;}
	}
}

/*
 ============================================================================
 Plugin Utility Functions
 ============================================================================
 */

// Link the plugin pointed to by path to the Plugin struct plug.
BOOL linkPlugin(char *path, Plugin *plug){
	strlwr(path);
	plug->instance = LoadLibrary(path);
	
	if (plug->instance != NULL){
		strcpy(plug->path, path);
		strcpy(plug->name, getFileName(path));
		
		plug->BeginEx 	= (mybeginPluginEx)GetProcAddress(plug->instance, "beginPluginEx");
		plug->BeginSlit = (mybeginSlitPlugin)GetProcAddress(plug->instance, "beginSlitPlugin");
		plug->Begin 	= (mybeginPlugin)GetProcAddress(plug->instance, "beginPlugin");
		plug->End 	= (myendPlugin)GetProcAddress(plug->instance, "endPlugin");
		plug->Info 	= (mypluginInfo)GetProcAddress(plug->instance, "pluginInfo");
		plug->running 	= false;
		plug->updateavailable = false;
		plug->inuse 	= true;
		plug->slitable 	= false;
		plug->slitaidable = false;
		
		if (plug->Begin == NULL || plug->End == NULL){
			char buffer[100];
			sprintf(buffer, "Could not link to plugin functions in...\n\n%s", path);
			MessageBox(NULL, buffer, "BBPlugManager - LINK ERROR!", MB_OK | MB_ICONERROR);
			
			UnloadPlugin(plug);
			return false;
		}
		
		if(plug->BeginEx != NULL || plug->BeginSlit != NULL){
			plug->slitable = true;
		}
		
		// Find plugs that require aid with becomming slittable...
		if(plug->BeginEx == NULL && plug->BeginSlit != NULL){
			plug->slitaidable = true;
		}
	}else{
		char buffer[100];
		sprintf(buffer, "Could not link to plugin at...\n"
				"\n"
				"%s\n"
				"\n"
				"This plugin may not be compatible\n"
				"with your Shell or Operating System.", path);
		MessageBox(NULL, buffer, "BBPlugManager - LINK ERROR!", MB_OK | MB_ICONERROR);
		return false;
	}
	return true;
}

// Reactivate a plugin link using a previously stored plugin path
void reLinkPlugin(Plugin *plug){
	linkPlugin(plug->path, plug);
}

char *prepareBroamString(char *str){
	if(str == NULL) return "";
	if(STREQ(str, "")) return "";
	
	char result[1000];
	char buf[1000];
	char *ptr;
	
	ZeroMemory(result, 1000);
	ZeroMemory(buf, 1000);
	
	ptr = strtok(str, "@");
	while(ptr != NULL){
		sprintf(buf, "@%s\n", ptr);
		strcat(result, buf);
		ptr = strtok(NULL, "@");
	}
	
	result[999] = '\0';
	
	return result;
}

// Ask a plugin's Info() method for plugin information
void getPluginInfo(Plugin *plug){
	char buf[1000];
	if (plug->inuse && plug->instance != NULL){
		if(plug->Info != NULL){
			strcpy(plug->URL, plug->Info(PLUGIN_UPDATE_URL));
			if(!strstr(plug->URL, "http://") || STREQ(plug->URL, "") || STREQ(plug->URL, defaultUpdateURL)){
				strcpy(plug->URL, "");
			}
			
			strcpy(plug->name, plug->Info(PLUGIN_NAME));
			
			strcpy(buf, plug->Info(PLUGIN_BROAMS));
			if(!STREQ(buf, plug->Info(10000))){
				strcpy(plug->broams, prepareBroamString(buf));
			}else{
				strcpy(plug->broams, "");
			}
		}else{
			strcpy(plug->name, getFileName(plug->path));
		}
	}else if(plug->instance != NULL){
		strcpy(plug->name, getFileName(plug->path));
	}
}

// Load the specified plugin
void LoadPlugin(Plugin *plug){
	if(plug->instance == NULL){
		reLinkPlugin(plug);
	}
	
	if(plug->instance != NULL){
		if(plug->BeginEx != NULL && hSlit){
			plug->BeginEx(plug->instance, hSlit);
		}else if(plug->BeginSlit != NULL && hSlit && plug->slitaid){
			plug->BeginSlit(plug->instance, hSlit);
		}else{
			plug->Begin(plug->instance);
		}
		plug->running = true;
	}
	
	getPluginInfo(plug);
}

// Unload the specified plugin
void UnloadPlugin(Plugin *plug){
	if(plug->running)plug->End(plug->instance);
	plug->running = false;
	FreeLibrary(plug->instance);
	plug->instance = NULL;
}

/*
 ============================================================================
 Misc. Utility Functions
 ============================================================================
 */

char *toUpper(char *str){
	char *ptr;
	ptr = str;
	while(*ptr != '\0'){
		*ptr = toupper(*ptr);
		ptr++;
	}
	return str;
}

// adds the HTTP protocol to a URL is no protocol is specified...
void fixURL(char *URL){
	if (!strstr(URL, "://")){
		char tempPath[MAX_PATH];
		strcpy(tempPath, "http://");
		strcat(tempPath, URL);
		strcpy(URL, tempPath);
	}
}

// make path absolute if not already...
void fixPath(char *path){
	if (!strstr(path, ":\\")){
		char tempPath[MAX_PATH];
		GetBlackboxPath(tempPath, MAX_PATH);
		strcat(tempPath, path);
		strcpy(path, tempPath);
	}
}

// get the File Name part of the url...
char *getURLFileName(char *URL){
	char *temp, *divider;
	
	divider = URL;
	temp = URL;
	while((temp = strstr(temp, "/")) != NULL){
		temp++;
		divider = temp;
	}
	
	char filenm[MAX_PATH];
	ZeroMemory(filenm, MAX_PATH);
	
	strcpy(filenm, divider);
	
	return filenm;
}

// get the File Name part of the url...
char *getFileName(char *path){
	char *temp, *temp2, *divider;
	
	divider = path;
	temp = path;
	temp2 = path;
	while((temp = strstr(temp, "\\")) != NULL || (temp2 = strstr(temp2, "/")) != NULL){
		if(temp2 > temp){
			temp = temp2;
		}else{
			temp2 = temp;
		}
		temp++;
		temp2++;
		divider = temp;
	}
	
	char filenm[MAX_PATH];
	ZeroMemory(filenm, MAX_PATH);
	
	strcpy(filenm, divider);
	
	return filenm;
}

// get the Directory part of an ordinary windows file path...
char *getFileDir(char *URL){
	char *temp, *temp2, *divider;
	
	divider = URL;
	temp = URL;
	temp2 = URL;
	while((temp = strstr(temp, "\\")) != NULL || (temp2 = strstr(temp2, "/")) != NULL){
		if(temp2 > temp){
			temp = temp2;
		}else{
			temp2 = temp;
		}
		temp++;
		temp2++;
		divider = temp;
	}
	
	char filenm[MAX_PATH];
	ZeroMemory(filenm, MAX_PATH);
	
	for(int n = 0; n < (divider - URL); n++){
		filenm[n] = URL[n];
	}
	
	return filenm;
}

char *CleanString(char *str)
{
	if (!strlen(str))
		return NULL;
	
	char *buffer = new char[strlen(str) + 1];
	ZeroMemory(buffer, strlen(str) + 1);
	
	strcpy(buffer, str);
	
	char *first, *last, *temp;
	first = strtok(buffer, " \t\r\n");
	if(first == NULL)
		return NULL;
	
	last = strstr(str, first) + strlen(first);
	first = strstr(str, first);
	
	while((temp = strtok(NULL, " \t\r\n")) != NULL){
		last = strstr(str, temp) + strlen(temp);
	}
	
	ZeroMemory(buffer, strlen(str) + 1);
	
	strncpy(buffer, first, last - first);
	
	ZeroMemory(str, strlen(str) + 1);
	
	strcpy(str, buffer);
	
	return str;
}

/*
 ============================================================================
 Internet Download Functions
 ============================================================================
 */

// Edited by Kaloth from the original DownloadFile by qwilk.
bool DownloadFile(char *url, char *path)
{
	fixURL(url);
	
	HINTERNET iopen = NULL, iopenurl = NULL;

	iopen = InternetOpen("BBPlugManager", INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);//INTERNET_FLAG_ASYNC);
	if (iopen)
	{
		// Set the connection timeout...
		int timeout = 10000;
		InternetSetOption(iopen, INTERNET_OPTION_RECEIVE_TIMEOUT, &timeout, sizeof(timeout));
		
		iopenurl = InternetOpenUrl(iopen, url, NULL, 0, INTERNET_FLAG_RELOAD, 0);
		if (iopenurl)
		{
			// unsigned int size = 0;
			// InternetQueryDataAvailable(iopenurl, (LPDWORD)&size, 0, 0);
			
			char buffer[1024];
			DWORD bytesRead = 0, retLength = 0;
			
			CleanString(path);
			
			// Create the file...
			FILE *file = fopen(path, "wb");
			if (file != NULL)
			{
				// Download data in chunks of 1024 bytes...
				while (InternetReadFile(iopenurl, (LPVOID)buffer, 1024, &bytesRead))
				{
					if (bytesRead == 0) break;
					fwrite(buffer, bytesRead, 1, file);
				}

				fclose(file);
				InternetCloseHandle(iopenurl);
				InternetCloseHandle(iopen);
				
				// If zip archive, unzip it! -- Added by Kaloth.
				if(strstr(path, ".zip")){
					char buff[MAX_PATH];

					strcpy(buff, getFileName((char *)path));
					sprintf(buffer, "The update included a zip archive called %s.\n"
							"Would you like to extract it now? If yes, then\n"
							"you will be prompted for a folder to extract it to.", buff);
					if(IDYES == MessageBox(0, buffer, szVersion, MB_YESNO | MB_ICONINFORMATION| MB_TOPMOST)){
						char directory[10000];
						LPCITEMIDLIST result;
						
						BROWSEINFO binfo;
							binfo.hwndOwner = hwndPlugin;
							binfo.pidlRoot = NULL;
							binfo.lpszTitle = "Select the folder to extract to...";
							binfo.ulFlags = BIF_RETURNONLYFSDIRS;
							binfo.pszDisplayName = buffer;
							binfo.lpfn = NULL;
							binfo.lParam = NULL;
							binfo.iImage = NULL;

						
						if((result = SHBrowseForFolder(&binfo)) != NULL){
							SHGetPathFromIDList(result, directory);
							CleanString(directory);
							if(directory[strlen(directory)-1] != '\\')strcat(directory, "\\");
							//MessageBox(0, directory, szVersion, MB_OK | MB_ICONINFORMATION | MB_TOPMOST);
							strcpy(buff, unzip((char  *)path, directory));
							if(!STREQ(buff, "")){
								sprintf(buffer, "The zip archive extraction produced the following message...\n\n%s", buff);
								MessageBox(0, buffer, szVersion, MB_OK | MB_ICONINFORMATION | MB_TOPMOST);
							}
						}
					}
				}

				return true;
			}
			else
			{
				fclose(file);
				InternetCloseHandle(iopenurl);
				InternetCloseHandle(iopen);
			}
		}
		else InternetCloseHandle(iopen);
	}

	return false;
}

// Edited by Kaloth from the original DownloadFile by qwilk.
bool DownloadFile_Merge(char *url, char *path)
{
	fixURL(url);
	
	HINTERNET iopen = NULL, iopenurl = NULL;

	iopen = InternetOpen("BBPlugManager", INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);//INTERNET_FLAG_ASYNC);
	if (iopen)
	{
		// Set the connection timeout...
		int timeout = 10000;
		InternetSetOption(iopen, INTERNET_OPTION_RECEIVE_TIMEOUT, &timeout, sizeof(timeout));
		
		iopenurl = InternetOpenUrl(iopen, url, NULL, 0, INTERNET_FLAG_RELOAD, 0);
		if (iopenurl)
		{
			// unsigned int size = 0;
			// InternetQueryDataAvailable(iopenurl, (LPDWORD)&size, 0, 0);

			char buffer[1024];
			DWORD bytesRead = 0, retLength = 0;

			// Create the file...
			FILE *file = fopen(path, "a");
			if (file != NULL)
			{
				// Download data in chunks of 1024 bytes...
				while (InternetReadFile(iopenurl, (LPVOID)buffer, 1024, &bytesRead))
				{
					if (bytesRead == 0) break;
					fwrite(buffer, bytesRead, 1, file);
				}
				
				fclose(file);
				InternetCloseHandle(iopenurl);
				InternetCloseHandle(iopen);
				
				return true;
			}
			else
			{
				fclose(file);
				InternetCloseHandle(iopenurl);
				InternetCloseHandle(iopen);
			}
		}
		else InternetCloseHandle(iopen);
	}

	return false;
}

char *extractZipPart(unzFile zipfile, char *directory){
	if(unzOpenCurrentFile(zipfile) != UNZ_OK)
		return "ERROR";
	
	char buff[MAX_PATH];
	char buff2[MAX_PATH];
	
	unzGetCurrentFileInfo(zipfile,
			     NULL,
			     buff,
			     MAX_PATH,
			     NULL,
			     0,
			     NULL,
			     0);
	
	strcpy(buff2, directory);
	strcat(buff2, buff);
	
	//MessageBox(0, buff2, szVersion, MB_OK | MB_ICONINFORMATION | MB_TOPMOST);
	
	strcpy(buff, getFileDir(buff2));
	//MessageBox(0, buff, szVersion, MB_OK | MB_ICONINFORMATION | MB_TOPMOST);
	mkdir(buff);
	
	FILE *dstfile;
	dstfile = fopen(buff2,"wb");
	if (dstfile == NULL){
		unzCloseCurrentFile(zipfile);
		return "ERROR";
	}
	
	char fbuff[1024];
	int num;
	
	while((num = unzReadCurrentFile(zipfile, fbuff, 1024))){
		fwrite(fbuff, num, 1, dstfile);
	}
	
	fclose(dstfile);
	unzCloseCurrentFile(zipfile);
	return buff2;
}

// Unzips a zip file to it's current directory...
char *unzip(char *filename, char *directory){
	char buff[MAX_PATH];
	
	unzFile zipfile = unzOpen(filename);
	if(zipfile == NULL)
		return "Could Not Open Zip";
	
	int numfiles, current = 0, n;
	unz_global_info ginfo;
	unzGetGlobalInfo(zipfile, &ginfo);
	numfiles = ginfo.number_entry;
	char **files;
	
	files = (char **)malloc(numfiles * sizeof(char *));
	for(n = 0; n < numfiles; n++){
		files[n] = (char *)malloc(MAX_PATH);
	}
	
	// Get the first file of in the zip...
	if(unzGoToFirstFile(zipfile) != UNZ_OK){
		unzClose(zipfile);
		return "Could Not Find Files In Zip";
	}
	
	// Extract each file from the zip...
	while(true){
		// Read from file...
		strcpy(files[current], extractZipPart(zipfile, directory));
		if(STREQ(files[current], "ERROR")){
			unzClose(zipfile);
			return "Error Extracting File";
		}
		current++;
		// Get Next File...
		if(unzGoToNextFile(zipfile) == UNZ_END_OF_LIST_OF_FILE){
			// Break loop if we have extracted all the files.
			break;
		}
	}
	
	char buff2[MAX_PATH];
	// Display file report...
	strcpy(buff, "The following files where extracted...\n\n");
	for(n = 0; n < numfiles; n++){
		strcpy(buff2, buff);
		sprintf(buff, "%s%s\n", buff2, files[n]);
	}
	MessageBox(0, buff, szVersion, MB_OK | MB_ICONINFORMATION | MB_TOPMOST);
	
	for(n = 0; n < numfiles; n++){
		free(files[n]);
	}
	free(files);
	
	// Get Comment then close and return...
	unzGetGlobalComment(zipfile, buff, MAX_PATH);
	unzClose(zipfile);
	return buff;
}

/*
 ============================================================================
 Window Transparency/Sticky Functions...
 ============================================================================
 */

int isIncluded_Trans(char *winclass){
	if(STREQ(winclass, ""))
		return 0;
	for(int n = 0; n < MAX_CLASSES; n++){
		if(!STREQ(classes[n], "")){
			if(STREQ(winclass, classes[n])){
				return 1;
			}
		}
	}
	return 0;
}

int isIncluded_Sticky(char *winclass){
	if(STREQ(winclass, ""))
		return 0;
	for(int n = 0; n < MAX_CLASSES; n++){
		if(!STREQ(sticky[n], "")){
			if(STREQ(winclass, sticky[n])){
				return 1;
			}
		}
	}
	return 0;
}

void makeWindowTransparent(HWND hwnd, char transparency, char *module){
	if(IsWindow(hwnd)){
		if(STREQ(module, ""))
			return;
		if(transparency != 255){
			// Add the WS_EX_LAYERED atribute to the window.
			SetWindowLong(hwnd, GWL_EXSTYLE , GetWindowLong(hwnd, GWL_EXSTYLE) | WS_EX_LAYERED);
			// Look at what settings it already had...
			COLORREF colour = NULL;
			GetLayeredWindowAttributes(hwnd, &colour, NULL, NULL);
			// Make it transparent.
			SetLayeredWindowAttributes(hwnd, colour, transparency, (colour == NULL)?LWA_ALPHA:LWA_ALPHA|LWA_COLORKEY);
		}else{
			// Look at what settings it already had...
			COLORREF colour = NULL;
			GetLayeredWindowAttributes(hwnd, &colour, NULL, NULL);
			if(colour == NULL){
				// Remove the WS_EX_LAYERED atribute to the window.
				SetWindowLong(hwnd, GWL_EXSTYLE, GetWindowLong(hwnd, GWL_EXSTYLE) & ~WS_EX_LAYERED);
			}else{
				// Make it opaque.
				SetLayeredWindowAttributes(hwnd, colour, globalTransAlpha, (colour == NULL)?LWA_ALPHA:LWA_ALPHA|LWA_COLORKEY);
			}
		}
	}
}

// Callback function that will recieve all the windows.
BOOL CALLBACK EnumWindowTransparencyInit(HWND hwnd, LPARAM lParam){
	if(IsWindow(hwnd)){
		TCHAR buffer[50];
		TCHAR buffer2[50];
		DWORD pid, count;
		HMODULE hm[1];
		HANDLE hProcess;
		
		GetWindowThreadProcessId(hwnd, &pid);
		hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, 0, pid);
		EnumProcessModules(hProcess, hm, sizeof(hm), &count);
		GetModuleFileNameEx(hProcess, hm[0], buffer, sizeof(buffer));
		CloseHandle(hProcess);
		RealGetWindowClass(hwnd, buffer2, sizeof(buffer2));
		
		if(globalTransparency && isIncluded_Trans(buffer2)){
			makeWindowTransparent(hwnd, globalTransAlpha, buffer);
		}
		
		if(globalSticky && isIncluded_Sticky(buffer2)){MakeSticky(hwnd);}
	}
	return 1;
}

VOID CALLBACK WinEventProc(	HWINEVENTHOOK hWinEventHook, DWORD event, HWND hwnd, 
				LONG idObject, LONG idChild, DWORD dwEventThread, DWORD dwmsEventTime){			
	int n;
	TCHAR buffer[50];
	TCHAR buffer2[50];
	DWORD pid, count;
	HMODULE hm[1];
	HANDLE hProcess;
	
	GetWindowThreadProcessId(hwnd, &pid);
	hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, 0, pid);
	EnumProcessModules(hProcess, hm, sizeof(hm), &count);
	GetModuleFileNameEx(hProcess, hm[0], buffer, sizeof(buffer));
	CloseHandle(hProcess);
	RealGetWindowClass(hwnd, buffer2, sizeof(buffer2));
	
	if(globalTransparency && isIncluded_Trans(buffer2)){
		switch(event){
			case EVENT_OBJECT_CREATE:
				makeWindowTransparent(hwnd, globalTransAlpha, buffer);
				break;
		}
	}
	
	if(globalSticky && isIncluded_Sticky(buffer2)){MakeSticky(hwnd);}
}

// Callback function that will recieve all the windows.
BOOL CALLBACK EnumWindowsOpaque(HWND hwnd, LPARAM lParam){
	if(IsWindow(hwnd)){
		TCHAR buffer[50];
		TCHAR buffer2[50];
		DWORD pid, count;
		HMODULE hm[1];
		HANDLE hProcess;
		
		GetWindowThreadProcessId(hwnd, &pid);
		hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, 0, pid);
		EnumProcessModules(hProcess, hm, sizeof(hm), &count);
		GetModuleFileNameEx(hProcess, hm[0], buffer, sizeof(buffer));
		CloseHandle(hProcess);
		RealGetWindowClass(hwnd, buffer2, sizeof(buffer2));
		
		if(isIncluded_Trans(buffer2)){makeWindowTransparent(hwnd, 255, buffer);} // make all windows opaque.
		if(isIncluded_Sticky(buffer2)){RemoveSticky(hwnd);} // make all windows opaque.
	}
	return 1;
}

void hook(){
	eventhook_CREATE = SetWinEventHook(
		EVENT_OBJECT_CREATE,
		EVENT_OBJECT_CREATE,
		GetModuleHandle(NULL),
		(WINEVENTPROC) WinEventProc,
		0, // get stuff from all processes.
		0, // all threads.
		WINEVENT_OUTOFCONTEXT | WINEVENT_SKIPOWNTHREAD); // Don't look at ourself because we'll get an infinite loop ;p
	
	// Initialise all the always transparent windows.
	EnumWindows((WNDENUMPROC)EnumWindowTransparencyInit, NULL);
}

void unhook(){
	UnhookWinEvent(eventhook_CREATE);
	
	// make all windows opaque.
	EnumWindows((WNDENUMPROC)EnumWindowsOpaque, NULL);
}

// Function that uninstalls all hooks.
void UnhookKB(){
	if (HKbHook != 0){UnhookWindowsHookEx(HKbHook);}
	HKbHook = 0;
}

void recordWindowClass(){
	POINT pt;
	GetCursorPos(&pt);
	HWND hwnd = WindowFromPoint(pt);

	TCHAR buffer[50];
	
	RealGetWindowClass(hwnd, buffer, sizeof(buffer));
	
	int n;
	
	if(lookingforwindowmode == STICKY){
		for(n = 0; n < MAX_CLASSES; n++){
			if(STREQ(sticky[n], "")){
				strcpy(sticky[n], buffer);
				break;
			}
		}
	}else{
		for(n = 0; n < MAX_CLASSES; n++){
			if(STREQ(classes[n], "")){
				strcpy(classes[n], buffer);
				break;
			}
		}
	}
	
	EnumWindows((WNDENUMPROC)EnumWindowTransparencyInit, NULL);
	
	TCHAR buffer2[MAX_PATH];
	
	if(lookingforwindowmode == STICKY){
		if(n != MAX_CLASSES){
			sprintf(buffer2, "BBPlugManager.plugin.stickyClass%d:", n);
			WriteString(rcpath, buffer2, sticky[n]);
		}else{
			MessageBox(0, "You have filled all the available slots!", szVersion, MB_OK | MB_ICONERROR | MB_TOPMOST);
		}
	}else{
		if(n != MAX_CLASSES){
			sprintf(buffer2, "BBPlugManager.plugin.transClass%d:", n);
			WriteString(rcpath, buffer2, classes[n]);
		}else{
			MessageBox(0, "You have filled all the available slots!", szVersion, MB_OK | MB_ICONERROR | MB_TOPMOST);
		}
	}
	
	UnhookKB();
	lookingforwindow = false;
}

// The keyboard hook procedure.
LRESULT CALLBACK MyKBHook(int Code, WPARAM wParam, LPARAM lParam){
	if(Code >= 0 && wParam == WM_KEYDOWN){
		KBDLLHOOKSTRUCT *key = (KBDLLHOOKSTRUCT *)lParam;
		MMRESULT result;
		if(key->vkCode == VK_SPACE){
			recordWindowClass();
		}
	}
	
	// Call the next hook in the chain.
	return CallNextHookEx(HKbHook, Code, wParam, lParam);
}

// Function that is used to install the keyboard hook.
void HookKb(){
	HKbHook = SetWindowsHookEx(WH_KEYBOARD_LL, (HOOKPROC)MyKBHook, GetModuleHandle(NULL), 0);
}

void AddWindowClass_Sticky(){
	if(!lookingforwindow){
		lookingforwindow = true;
		lookingforwindowmode = STICKY;
		MessageBox(0, 	"The next time you press the space bar (after closing\n"
			"this message) BBPlugManager will record the class\n"
			"of the window your mouse was over and add it to\n"
			"it's list of window classes to make sticky :)\n"
			"\n Hint: With windows that have a title bar make\n"
			"         sure you hover the mouse over that bar\n"
			"         when you press space.", szVersion, MB_OK | MB_ICONINFORMATION | MB_TOPMOST);
	
		HookKb();
	}
}

void AddWindowClass_Trans(){
	if(!lookingforwindow){
		lookingforwindow = true;
		lookingforwindowmode = TRANS;
		MessageBox(0, 	"The next time you press the space bar (after closing\n"
			"this message) BBPlugManager will record the class\n"
			"of the window your mouse was over and add it to\n"
			"it's list of window classes to apply transparency to :)\n"
			"\n Hint: With windows that have a title bar make\n"
			"         sure you hover the mouse over that bar\n"
			"         when you press space.", szVersion, MB_OK | MB_ICONINFORMATION | MB_TOPMOST);
	
		HookKb();
	}
}

/*
 ============================================================================
 Menu Clipper Functions...
 ============================================================================
 */

BOOL isBBMenu(char *str){
	return (strstr(strlwr(str), strlwr(bbpath)) != NULL);
}

VOID CALLBACK WinEventProc_MENU(HWINEVENTHOOK hWinEventHook, DWORD event, HWND hwnd, 
				LONG idObject, LONG idChild, DWORD dwEventThread, DWORD dwmsEventTime){			
	int n;
	TCHAR buffer[50];
	TCHAR buffer2[50];
	DWORD pid, count;
	HMODULE hm[1];
	HANDLE hProcess;
	
	GetWindowThreadProcessId(hwnd, &pid);
	hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, 0, pid);
	EnumProcessModules(hProcess, hm, sizeof(hm), &count);
	GetModuleFileNameEx(hProcess, hm[0], buffer, sizeof(buffer));
	CloseHandle(hProcess);
	RealGetWindowClass(hwnd, buffer2, sizeof(buffer2));
	
	if(!isBBMenu(buffer)){
		// If not the bb menu then hide the bb menu...
		SendMessage(hwndBlackbox, BB_HIDEMENU, 0, 0);
	}
}

void StartMenuClipper(){
	eventhook_MENU = SetWinEventHook(
		EVENT_SYSTEM_FOREGROUND,
		EVENT_SYSTEM_FOREGROUND,
		GetModuleHandle(NULL),
		(WINEVENTPROC) WinEventProc_MENU,
		0, // get stuff from all processes.
		0, // all threads.
		WINEVENT_OUTOFCONTEXT | WINEVENT_SKIPOWNTHREAD); // Don't look at ourself because we'll get an infinite loop ;p
	
}

void EndMenuClipper(){
	UnhookWinEvent(eventhook_MENU);
}

/*
 ============================================================================
 Plugin Theme Functions...
 ============================================================================
 */

char *BBPM_plugrcPath(){
	char rcpath[MAX_PATH], path[MAX_PATH];
	GetModuleFileName(hInstance, rcpath, sizeof(rcpath));
	strcpy(path, getFileDir(rcpath));
	strcat(path, plugRCFileName);
	strcpy(rcpath, path);
	
	if(!FileExists(rcpath)){
		fclose(fopen(rcpath, "w"));
	}
	
	return rcpath;
}
